import React, {Component} from 'react';

interface FixedState {
    clicked: boolean
}

class Fixed extends Component<{}, FixedState> {

    constructor(props: {}) {
        super(props);
        this.state = {
            clicked: false
        };
    }

    handleClick = () => {
        this.setState({
            clicked: true
        });
        console.log("Clicked!");
    };

    render() {
        let message;
        if (this.state.clicked) {
            message = "I've been clicked!";
        } else {
            message = "Click me!";
        }

        return (
            <div>
                <p>{message}</p>
                <button onClick={this.handleClick}>Click Here</button>
            </div>
        );
    }

}

export default Fixed;
